10 '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
20 ' renumber.bas
30 ' Geoff Graham 2010    http://geoffg.net
35 ' updated by James Deakins February 2013 to use newer functions 
40 ' of MMBasic V4.3
45 '
50 ' This program will renumber a basic program including references
60 ' to line numbers in statements.  It is written for MMBasic.
96 '
97 ' For comparison, Geoff's original program was 218 lines.  This is over
98 ' 700 lines.
99 '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
100 '
105 Option Base 1 ' Arrays start with entry 1, not 0
106 '
110 false = 0 : true = NOT false
115 bDebug = False
120 defaultStart = 1 : defaultFirst = 10 : defaultIncrement = 10
130 ' 
140 MaxParams = 20
150 DIM Param$(MaxParams)   ' the parameters after a keyword 
160 DIM ParamPtr(MaxParams) ' the pointer position of start of parameters 
161 '
162 DATA "THEN","GOTO","GOSUB","ELSE","SETPIN","SETTICK" 
163 KeyWords = 6  ' update this if you change the list of keywords.
164 DIM KeyWord$(KeyWords)
165 For n = 1 to KeyWords
166   Read kw$
167   KeyWord$(n) = kw$
168 Next n
170 '
180 PRINT "This program will renumber a BASIC program including references"
190 PRINT "to line numbers in GOSUB, GOTO, etc.  Minimal error checking"
200 PRINT "is done so the program must run correctly before renumbering."
210 PRINT
220 INPUT "Program to renumber: ", iname$
225 If iname$ = "" then iname$ = "testfile.bas"
230 LinesInFile = CountLines(iname$) 
232 DIM lines(LinesInFile)
233 DIM DQuotes(LinesInFile)
    DIM Remarks(LinesinFile,2) ' first entry is posn of single quote, second is posn of REM
234 ' DIM labelLines(LinesInFile)       'TODO use it
235
236 OPEN iname$ FOR input  AS #1 
237 '
240 INPUT "   Output file name: ", oname$
245 If oname$ = "" then oname$ = "renum-ed.bas"
250 OPEN oname$ FOR output AS #2
260 '
' 270 PRINT : PRINT "In the input file, what is the desired:"
' 275 PRINT "(Default"; defaultStart; ")"; :     INPUT "  Line num where renumbering is to start (Enter key for default)"; In$
' 280 If In$ = "" then start = defaultStart else start = VAL(In$)
285 PRINT : PRINT "In the output file, what is the desired:"
290 PRINT "(Default"; defaultFirst; ")"; :     INPUT " First num to be used in the new sequence (Enter key for default)"; In$
295 If In$ = "" then first = defaultFirst else first = VAL(In$)
300 PRINT "(Default"; defaultIncrement; ")"; : INPUT "                 Increment for each line (Enter key for default)"; In$
302 If In$ = "" then increment = defaultIncrement else increment = VAL(In$)
304 '
305 'Get the length of the max line number so we can get neat spacing
306 MaxLineNum = first +((LinesInFile - 1)*increment)
307 MaxLineNum$ = Str$(MaxLineNum)
308 MaxLineNumLen = len(MaxLineNum$)
310 '
320 '
330 '
340 PRINT : PRINT "Checking for some of the potential problems.... "
350 'Pass one of the file - store the line numbers as integers in lines array
351 ' Warn the user if any lines are out of order (an easy source of errors!)
352 ' Warn if any old style remarks signified by REM might be used.
353 ' TODO Identify any labels and record the length of the longest one.
354 '--------------------------
356 PrevNum = 0
357 bLinesNotInOrder = False
358 bREMstatements = False
360 FOR LineNum = 1 to LinesInFile 
370   Line INPUT #1, inp$
372   ' store the line number
375   ThisNum = VAL(inp$)
380   lines(LineNum) = ThisNum
382   ' Check for lines out of order
385   If (ThisNum <= PrevNum) AND (ThisNum <> 0) Then ' a blank line number (allowable) will return zero
386     PRINT "File line"; LineNum; " has its program linenumber ("; ThisNum; " ) out of order!"
387     bLinesNotInOrder = True
388   Endif
389   ' Check how many double quotes (may hold REM, single quote or colon which are all searched for further down in program)
390   DQCount = 0
391   DQStart = INSTR(1, inp$, chr$(34)) ' search for the next double quote    
392   DO While DQStart > 0)
393     DQCount = DQCount + 1
394     DQStart = INSTR(DQStart + 1, inp$, chr$(34))
395   LOOP
399   DQuotes(LineNum) = DQCount

400   ' Check for REM  
401   UCLine$ = UCASE$(inp$)

      ' check for a single quote, because we only care about REM if it's BEFORE a single quote
      SQPosn = INSTR(1, UCLine$, "'")
      bSQFound = False
      DO While (SQPosn > 0) and (NOT bSQFound)
        if NOT InDoubleQuotes(SQPosn, UCLine$) then ' make sure it isn't in double quotes, like "Henry's"
           bSQFound = True
        else
           SQPosn = INSTR(SQPosn + 1, UCLine$, "'")
        endif
      Loop 
      Remarks(LineNum,1) = SQPosn
      if SQPosn = 0 THEN
         SQPosn = LEN(UCLine$) ' if there isn't a single quote, assume one at the far right of the line 
      endif
      
402   RemPosn = GetNextREM(1, UCLine$)
403   DO While (RemPosn > 0) AND (NOT bREMstatements) AND (RemPosn < SQPosn) ' only search up to the single quote
404     if DQCount > 0 then
407       if NOT InDoubleQuotes(RemPosn, UCLine$) then
408         bREMstatements = True
409       endif
        else ' no double quotes in line
          bREMstatements = True 
410     endif
        if NOT bREMstatements then
411       RemPosn = GetNextREM(RemPosn + 1, UCLine$)
        endif
412   LOOP   
      Remarks(LineNum, 2) = RemPosn  
413   if Thisnum > 0 then ' don't bother updating if it was a label
414     PrevNum = ThisNum
      endif
415 Next LineNum
416 CLOSE #1
417 '
420 '
421 if bLinesNotInOrder Then
      ?
422   ? "Duplicate line numbers were found, or lines are out of order."
423   ? "Only the first duplicate or out-of-order line number of a set is"
424   ? "identified, so also check the line numbers below the ones identified."
425   ?
426   ? "You should only continue with the renumbering process if you are "
427   ? "really sure of what you are doing!"
428   ?
429   Input "Line Number errors found.  Continue with Renumbering (Y/N)"; In$
430   if Ucase$(In$) = "N" then END
431 endif
432 '
    if bREMstatements Then
      ?
      ? "WARNING: Old style REM statements were found (REM is the "
      ? "older way to signifying remarks).  This program identifies "
      ? "REM statements by searching for 'REM ', so be careful using "
      ? "variable names ending in rem, like Harem, Spirem, Theorem "
      ? "or Millirem in your program. "
      ? "Although the program has been written to account for the "
      ? "various ways the REM string might appear in your program, "
      ? "it is not guaranteed to work in all cases. "
      ? "If you decide to continue with the renumbering process, "
      ? "check the result carefully. "
      ?
      INPUT "Do you want to continue (Y/N)"; In$
      if Ucase$(In$) = "N" Then END
    endif

433 'Pass 2 of the file - renumber to output file
434 ' -----------------
435 PRINT : PRINT "Writing to Output File: "
440 OPEN iname$ FOR INPUT AS #1  
450 FOR lineindex = 1 TO LinesInFile  
460   LINE INPUT #1, inp$ 
465   if bDebug Then ? "Original line is >>>";inp$;"<<<"
470   ProcessedLine$ = ProcessLine$(inp$, lineindex)
480   PRINT #2, ProcessedLine$    ' send to Output file 
490   PRINT ".";  
500 NEXT lineindex   
510 '  
520 CLOSE #1, #2
530 PRINT  
540 PRINT "Finished.  Processed";LinesInFile;" lines"  
550 END  
560 '  
570 '
580 '
590 '  
600 ''''''''''''''''''''''''''''''''''''''''''''  
610 'subroutines and functions 
620 ''''''''''''''''''''''''''''''''''''''''''''  
700 '  
710 '  
720 '  
730 ''''''''''''''''''''''''''''''''''''''''''''  
740 'Function  
750 'process a line (in pInp$) and replace all  
760 'line numbers.  returns with pInp$ updated  
770 ''''''''''''''''''''''''''''''''''''''''''''
Function ProcessLine$(pInp$, pLineIndex)  
Local original$, newptr
'
original$ = pInp$ 
ptr = 1

' move pointer past any leading spaces
ptr = MovePtrPastSpaces(pInp$, ptr)

' move pointer past line number
ptr = MovePtrPastLineNumber(pInp$, ptr, LineNum) ' linenumber is returned in LineNum

'insert the new line number.  
If lines(pLineIndex) > 0 THEN ' it has a line number
' TODO test for "Start Line" will go here - If lines(pLineIndex) < start then use original line number with original code etc, but adjust indent.
' TODO if labels exist, ask users if they want code indented to the length of the longest label (do after pass 1) and 
'      adjust the indent accordingly (here).
  NewLineNum = first +((lineindex-1)*increment)
  NewLineNumLength = len(str$(NewLineNum)) 
  Indent$ = space$(MaxLineNumLen - NewLineNumLength)
  newline$ = STR$(NewLineNum)+ Indent$ + MID$(inp$, ptr)
Else ' no line number
  n = INSTR(ptr, inp$, ":")
  if n > 0 then ' could be a label without a line number
    bLabel = True
    for i = ptr to n 
      ch$ = MID$(inp$, i, 1)
      if (ch$ = " ") then bLabel = False ' a label is a string immediately followed by a colon, so cannot have a space
    next i
    if bLabel then
      newLine$ = mid$(inp$, ptr) ' output with no indent (ie, at start of line)
    else     
      newline$ = space$(MaxLineNumLen + ptr) + MID$(inp$, ptr) ' ? "colon in multi statement.  Not a label. 
    endif
  else   
    newline$ = space$(MaxLineNumLen + ptr) + MID$(inp$, ptr)  ' ? "no colon, no line number"
  endif
Endif  

if bDebug then ? "after new line num added >>>";newline$;"<<<"

' we leave the code above with the (possibly new) linenumber attached to the code and remarks.

UCnewline$ = UCASE$(newline$)
' A line can be made up of code and remarks.  Don't search for keywords in remarks.
' Separate the remarks from the code, and just process the code from now on.
' We will reattach the remarks after the code is processed.

' In pass one we stored pointers to the first ' and REM in the line that weren't in double quotes

' look for the start of remarks. Could be a single quote (') or REM.  If both, use the first one on the line.

ptrSingleQuote = Remarks(pLineIndex, 1)
ptrREM         = Remarks(pLineIndex, 2) 

ptrRemStart = ptrSingleQuote  'ptrRemStart will hold the earliest Start Of Remarks address, whether ' or REM

if (ptrREM > 0) then
  if ptrSingleQuote = 0 then 
    ptrRemStart = ptrREM
  elseif (ptrREM < ptrSingleQuote) Then
    ptrRemStart = ptrREM
  endif
endif

' Split the line into code and comments

If ptrRemStart > 0 Then
  LenDiff = LEN(newline$) - LEN(pInp$) ' we've probably added spacing to the beginning of the line
  ptrRemStart = ptrRemStart + LenDiff
  Remarks$ = MID$(newline$, ptrRemStart)
  Code$ = Left$(newline$, ptrRemStart - 1)
else  'it is all code 
  Remarks$ = ""
  Code$ = newline$ 
endif

if bDebug Then
  ? "ptrSQ is  >>>";ptrSingleQuote;"<<<"
  ? "ptrREM is >>>";ptrREM;"<<<"
  ? "LenDiff   >>>";LenDiff;"<<<"
  ? "Rem Start >>>";ptrRemStart;"<<<"
  ? "Code is   >>>";Code$;"<<<"
  ? "Rem  is   >>>";Remarks$;"<<<"
endif

' A code line may be made up of multiple statements separated by colons (:)
' Process each statement separately, and reassemble.

startOfStatement = 1
ProcessedLine$ = ""
DO 
    nextColon = INSTR(startOfStatement, Code$, ":")
    if nextColon = 0 then 
      endOfStatement = len(Code$)
    else
      endOfStatement = nextColon
    endif
    ' extract next statement and process it
    Statement$ = Mid$(Code$, startOfStatement, endOfStatement - startOfStatement + 1)
    If bDebug Then ? "Processing Statement >>>";Statement$;"<<<"
    ProcessedLine$ = ProcessedLine$ + ProcessStatement$(Statement$)
    if bDebug Then ? "New Line is now      >>>";ProcessedLine$;"<<<"
    startOfStatement = nextColon + 1 
Loop Until nextColon = 0

ProcessedLine$ = ProcessedLine$ + Remarks$   ' reattach remarks
if bDebug Then ? "And with Remarks reattached  >>>";ProcessedLine$;"<<<"
ProcessLine$ = ProcessedLine$

End Function ' ProcessLine$
'
'''''''''''''''''''''''''''''''''''''''''''''''
' Function
' Process the statement
' Return processed statement
'''''''''''''''''''''''''''''''''''''''''''''''
' Note: the original code by Geoff had separate
' processing for the ON command. The ON processing
' has now been rolled into the same code as GOTO
' and GOSUB.
' GOTO and GOSUB will handle both a single line
' number or label, or multiple ones separated by 
' commas.
'''''''''''''''''''''''''''''''''''''''''''''''
'
Function ProcessStatement$(pStatement$)
' NOTE: The newStatement$ will be a different length to pStatement$ if the new line numbrs embedded in it are different lengths 

Local i, newStatement$, UCstatement$, kwPtr ' points to posn of keyword in statement

bProcessedKeyword = false
newStatement$ = pStatement$

for i = 1 to KeyWords
  kw$ = KeyWord$(i)
  kwPtr = 1
  DO WHILE kwPtr <> 0
    kwPtr = INSTR(kwPtr, Ucase$(newStatement$), kw$)     ' find the keyword
    if bDebug then ? "Search for keyword ";kw$; " returned kwPtr ";kwptr; " (0 means not found)"
    IF kwPtr <> 0 THEN  
      IF NOT InDoubleQuotes(kwPtr, newStatement$) Then
        kwPtr = kwPtr + LEN(kw$)              'step over it.  pointer at char after end of keyword.
        newStatement$ = ProcessKeyWord$(kwPtr, newStatement$, kw$)
        bProcessedKeyword = True'
        if bDebug then ? "kwPtr returned was ";kwPtr
      ELSE 'it is in double quotes, so do not process it as a keyword
        kwPtr = kwPtr + LEN(kw$)              'step over it
      ENDIF
    ENDIF  
  LOOP 
Next i  

If bProcessedKeyword = False then ' no keywords found
  ' "No Keywords found.  Leave as is"
  newStatement$ = pStatement$ 
endif

ProcessStatement$ = newStatement$
End Function  ' ProcessStatement$      
'
'''''''''''''''''''''''''''''''''''''''''''''
' Function
' Function is passed a pointer to where the
' nominated keyword is in the nominated statement.
' Return processed statement and revised pointer.
'
'''''''''''''''''''''''''''''''''''''''''''''
' NOTE: old form of IF allowed linenumber directly 
' after THEN and ELSE, but had to all be on one line.
' Otherwise the GOTO linenumber and GOSUB linenumber 
' processing would handle the IF THEN ELSE statement.
'''''''''''''''''''''''''''''''''''''''''''''''''''''
'
Function ProcessKeyWord$(pPtr, pStatement$, pKw$) 

Local ptr, updatedPtr

updatedPtr = pPtr ' return value

' move past space/s
ptr = MovePtrPastSpaces(pStatement$, pPtr)

params = parse(pStatement$, ptr)

if pKw$ = "THEN" OR pKw$ = "ELSE" then ' for obsolete form - Then or Else immediately followed by line num or label
 
if bDebug then ? "Entering THEN or ELSE processing with keyword ";pKw$; " and param ";param$(1)

 P1$ = param$(1)
  endP1Ptr = paramPtr(1) + LEN(param$(1))
  if params = 0 then ' it's continued on the next line, so it can't be the obsolete form
    updatedStatement$ = pStatement$ ' so leave it as it is and the GOTO or GOSUB processing will handle it
    updatedPtr = LEN(Statement$)
  elseif ( UCASE$(P1$) = "GOTO" ) OR ( UCASE$(P1$) = "GOSUB" ) then
    ' "Next term is GOTO or GOSUB, so leaving pointer and statement as is"
    updatedStatement$ = pStatement$ ' gosub and goto processing will handle it
  elseif VAL(P1$) = 0 Then ' a label
    ' Next term is a label, so leaving it as is
    updatedStatement$ = pStatement$
   updatedPtr = endP1Ptr
  else
    ' "Updating obsolete form of Then or Else where the line numbr immediately follows the keyword (ie, no GOTO)"
    newNumber$ = LookupLine$(P1$)
    updatedStatement$ = Left$(pStatement$, paramPtr(1) - 1) + newNumber$ + MID$(pStatement$, endP1Ptr)
    updatedPtr = paramPtr(1) + LEN(newNumber$)
    if bDebug then 
      ? "Updated Statement is >>>";updatedStatement$;"<<<"
      ? "Balance of string is >>>";mid$(updatedStatement$, updatedptr);"<<<"
      ? "New pointer is ";updatedPtr
    endif
  endif  
    
elseif pKw$ = "GOTO" OR pKw$ = "GOSUB" then 

  if bDebug then ? "Entering GOTO or GOSUB processing with keyword ";pKw$; " and param ";param$(1)

  ProcessMultipleTargets(pStatement$, ptr, params)
  updatedStatement$ = pStatement$
  updatedPtr = ptr ' pass back up the call chain

elseif pKw$ = "SETPIN" then  ' param 3 optional
  
  if params = 2 then
    updatedStatement$ = pStatement$ ' doesn't use optional label or line number
    updatedPtr = paramPtr(2) + LEN(param$(2))
  else
    P3$ = param$(3) ' a label or line number
    endP3Ptr = paramPtr(3) + LEN(P3$)
    if VAL(P3$) = 0 then
      updatedStatement$ = pStatement$ ' a label
    else
      newNumber$ = LookupLine$(P3$)
      updatedStatement$ = Left$(pStatement$, paramPtr(3) - 1) + newNumber$ + MID$(pStatement$, endP3Ptr)
    endif
    updatedPtr = paramPtr(3) + LEN(newNumber$)
  endif 
    
elseif pKw$ = "SETTICK" then ' param 2 mandatory
' do not change if target (param 2) is 0, ie settick 0,0 but otherwise change the second parameter 
  
  if params = 2 then
    P2$ = param$(2)
    endP2Ptr = paramPtr(2) + LEN(P2$)
    if P2$ = "0" then
      updatedStatement$ = pStatement$ ' reset of SetTick interrupt.  Don't change!
    elseif VAL(P2$) = 0 then
      updatedStatement$ = pStatement$ ' a label
    else
      newNumber$ = LookupLine$(P2$)
      updatedStatement$ = Left$(pStatement$, paramPtr(2) - 1) + newNumber$ + MID$(pStatement$, endP2Ptr)
    endif
    updatedPtr = paramPtr(2) + LEN(newNumber$)
  else
      ? "Malformed SETTICK command: " + pStatement$
      INPUT "Press Ctrl-C to stop, any other key to continue "; In$
  endif
else 
  "You should never get this message.  The program tried to process the unknown keyword "; pKw$
  Input "Press Ctrl-C to break, or any other key to continue"; In$
endif

pPtr = updatedPtr
ProcessKeyWord$ = updatedStatement$    
 
End Function  ' ProcessKeyWord$
'
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Subroutine 
' This subroutine processes 1 or more labels or linenumbers separated by commas 
' and optional spaces following a GOTO or GOSUB keyword, and it also processes 
' the normal single label / linenumber calls like if x = 3 then goto 10 and, through 2
' separate calls to this subroutine, calls like If x = 3 then goto 10 else goto 20.
'
' enters the routine with the pointer pointing at the first character of the first token
' after the keyword, and the Param$ array holds the token values.
' Returns two values, updated pStatement$ and ptr.
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
Sub ProcessMultipleTargets(pStatement$, ptr, params)

Local updatedStatement$, P$, n, newNumber$, bExit

updatedStatement$ = Left$(pStatement$, ptr - 1) ' start with everything up to the start of first linenum/label
bExit = False
n = 1

if bDebug then ? "In ProcessMultipleStatements with pointer ";ptr; " and "; params ; " parameters"

DO While (n <= params) AND (NOT bExit)
  P$ = param$(n) 
  PLen = LEN(P$) 
  endPPtr = paramPtr(n) + PLen - 1
  if n < params then
    separator$ = mid$(pStatement$, endPPtr + 1, paramPtr(n+1) - endPPtr - 1)
  else
    if endPPtr = LEN(pStatement$) then ' for example, if the last token is a single character like :, there's nothing following it
      separator$ = ""
    else
      separator$ = mid$(pStatement$, endPPtr + 1)
    endif
  endif
  if VAL(P$) = 0 Then  ' a label
    updatedStatement$ = updatedStatement$ + P$ + separator$
  else
    newNumber$ = LookupLine$(P$)
    updatedStatement$ = updatedStatement$ + newNumber$ + separator$   
  endif

  UCP$ = UCASE$(param$(n+1))
  if UCP$ = "ELSE" then 
    bExit = True
  endif
  n = n + 1
Loop
ptr = endPPtr
pStatement$ = updatedStatement$   
End Sub   ' ProcessMultipleTargets

'
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Function
' Parse the string into tokens based on spaces and commas
' as separators.  Store the tokens in the global Param$ array.
' Store the offset within the original line of the start of 
' each token into another global array, ParamPtr.
'
' Returns the number of parameters in the array
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Function Parse(pStatement$, pPtr) 
Local i, n, nextChar$

' Clear the array that will hold the parameters
For i = 1 to MaxParams
  Param$(i) = ""
Next i

StatementLen = Len(pStatement$)

ParamNum = 0  
n = pPtr
' skip any leading spaces
NextChar$ = mid$(pStatement$, n, 1)
Do While NextChar$ = " "
  n = n + 1
  NextChar$ = mid$(pStatement$, n, 1)
Loop

' At this point we have skipped all the spaces (if any) after the keyword and are pointing at the first parameter

Do While n <= StatementLen
  Parameter$ = ""
  ParamNum = ParamNum + 1
  ParamPtr(ParamNum) = n
  
  Do While (NextChar$ <> " ") AND (NextChar$ <> ",") AND (n <= StatementLen)
    Parameter$ = Parameter$ + NextChar$
	n = n + 1
	NextChar$ = mid$(pStatement$, n, 1)
  Loop
  
  Param$(ParamNum) = Parameter$

    Do While ((NextChar$ = " ") OR (NextChar$ = ",")) AND (n <= StatementLen)
    n = n + 1
    NextChar$ = mid$(pStatement$, n, 1)
  Loop
Loop

if bDebug then
  for i = 1 to ParamNum
    ? "Param ";i; " is "; Param$(i)
  next i
endif

Parse = ParamNum
end Function   ' Parse
'
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Function
' Search the "lines" array to find the original line number.
' Return the value of the new line number.
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
Function LookupLine$(OldLine$)
Local bFound, i, OldLine

bFound = False
i = 1
OldLine = VAL(OldLine$)
Do While (i <= LinesInFile) AND NOT bFound
   IF lines(i) = OldLine THEN 
     bFound = True  
   Else
     i = i + 1
   Endif
Loop

if NOT bFound then
  PRINT : PRINT "No matching line number " + NextNumber$ + " found in original program."
  End  
Endif

if bDebug Then
  LookupLine$ = "***" + STR$(first + ((i - 1) * increment)) 'to ensure original and new are different lengths, and identify unprocessed linenums
else
  LookupLine$ = STR$(first + ((i - 1) * increment))
endif  
  
End Function   ' LookupLine$
2190 '
2200 '''''''''''''''''''''''''''''''''''''''''''''''''''''''
2210 'Function
2220 'Return the number of lines in the input file.
2230 '''''''''''''''''''''''''''''''''''''''''''''''''''''''
2240 'Note: Closes and reopens file so input pointer reset to start.
2250 '''''''''''''''''''''''''''''''''''''''''''''''''''''''
2260 Function CountLines(FileName$)
2270 local Count
2280 '
2285 OPEN FileName$ for INPUT as #3
2290 Count = 0
2300 DO WHILE NOT EOF(#3)
2310     Line Input #3, inp$
2320     Count = Count + 1
2330 LOOP
2340 Close #3
2350 
2360 CountLines = Count
2370 End Function   ' CountLines
2390 '
2400 '''''''''''''''''''''''''''''''''''''''''''''''''''''
2410 'Function
2420 'scan the line and move the pointer to the first 
2430 'character past any leading spaces
2440 '
2450 '''''''''''''''''''''''''''''''''''''''''''''''''''''
2455 ' 
2460 Function MovePtrPastSpaces(pStr$, pPtr)
2470 local ptr
2480
2490 ptr = pPtr
2500 DO WHILE mid$(pStr$,ptr,1) = " "
2510   ptr = ptr + 1
2520 LOOP
2530 MovePtrPastSpaces = ptr
2540 End Function   ' MovePtrPastSpaces
2570 '
2580 '''''''''''''''''''''''''''''''''''''''''''''''''''''
2590 'Function
2600 'scan the line and move the pointer to the first 
2610 'character past any leading spaces
2620 'note: function also updates LineNum parameter
2630 '''''''''''''''''''''''''''''''''''''''''''''''''''''
2635 ' 
2640 Function MovePtrPastLineNumber(pStr$, pPtr, LineNum)
2650 local ptr, nbrStr$
2660
2670 ptr=pPtr
2680 ' then get the number (if there)  
2690 nbrstr$ = ""  
2695 ch$ = MID$(pStr$,ptr,1)
2700 DO WHILE ch$ >= "0" AND ch$ <= "9"  
2710   ptr = ptr + 1
2720   nbrstr$ = nbrstr$ + ch$
2725   ch$ = MID$(pStr$,ptr,1)
2730 LOOP 
2740 LineNum = Val(nbrstr$) 
2750 MovePtrPastLineNumber = ptr
2760 End Function   ' MovePtrPastLineNumber

'
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Function
' Check whether the pointer is within a pair of double
' quotes.
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Note: needed to ensure we do not incorrectly see a colon,
' REM or single quote as being meaningful to the code
' when they are actually just part of an instruction
' such as THEN Y$ = "This is a colon:, a quote ', or REM "
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
Function InDoubleQuotes(Posn, UCLine$)
Local bInQuotes, StartPosn, EndPosn

bInQuotes = False
StartPosn = INSTR(1, UCLine$, chr$(34))
EndPosn = INSTR(StartPosn + 1, UCLine$, chr$(34))

DO While (StartPosn > 0) AND (EndPosn > 0) AND (bInQuotes = False)
  if (Posn > StartPosn) AND (Posn < EndPosn) Then
     bInQuotes = True
  else
    StartPosn = INSTR(EndPosn + 1, UCLine$, chr$(34))
    EndPosn = INSTR(StartPosn + 1, UCLine$, chr$(34))  
  endif
Loop

InDoubleQuotes = bInQuotes
End Function   ' InDoubleQuotes

'
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Function
' Get the next REM on the line
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' REM can occur at the beginning of a line with nothing before it.
' REM can occur immediately after a colon.
' Other than that, it must be preceded by a space.
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
Function GetNextREM(Posn, UCLine$)
Local i, bFound, REMPosn

REMPosn = 0
i = INSTR(Posn, UCLine$, "REM ")

DO While (REMPosn = 0) AND (i > 0)
  if i = 1 then 'start of line 'REM '
    REMPosn = i
  else
    if MID$(UCLine$, i-1, 1) = " " then ' REM '
      REMPosn = i
    else
      if MID$(UCLine$,i-1, 1) = ":" then ':REM '
        REMPosn = i
      endif
    endif
  endif
  i = INSTR(i + 1, UCLine$, "REM ")
LOOP

GetNextREM = REMPosn
End Function   ' GetNextREM